package com.yundong.third.ht.api.database.impl;

import cn.afterturn.easypoi.word.WordExportUtil;
import cn.afterturn.easypoi.word.entity.MyXWPFDocument;
import com.yundong.base.result.Result;
import com.yundong.base.service.oss.OssService;
import com.yundong.gateway.register.annotation.YdcGateway;
import com.yundong.third.ht.api.database.ContractWordServiceld;
import com.yundong.third.ht.api.database.dto.request.Contract;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.Service;
import org.apache.poi.xwpf.usermodel.XWPFDocument;
import org.springframework.beans.factory.annotation.Autowired;
import javax.validation.Valid;
import java.io.*;
import java.util.*;

@Slf4j
@org.springframework.stereotype.Service
@Service(version = "${dubbo.provider.version}", group = "${dubbo.provider.group}")

public class ContractWordServiceldImpl implements ContractWordServiceld {
    @Autowired
    private OssService ossService;
    @YdcGateway(name = "contract-word", url = "biz/third/md/database/ContractWord.json")
    @Override
    public Result<List<String>> contractWordExport(@Valid Contract request ) {
        Result<List<String>> result = new Result<>();
        List<String> fileUrls = new ArrayList<>();

        for(int i = 0; i < request.getData().size(); i++) {

            Contract obj = request.getData().get(i);
            String fileName = obj.getDESC1()+"-合同会签单.docx";
            HashMap<String, Object> map = new HashMap<>();
            map.put("DESC1", obj.getDESC1());
            map.put("DESC3", obj.getDESC3());
            map.put("DESC13", obj.getDESC13());
            map.put("dept", obj.getDept());
            map.put("deptLeader", obj.getDeptLeader());
            map.put("depts", obj.getDepts());
            map.put("handled_by", obj.getHandled_by());
            map.put("handling_dept", obj.getHandling_dept());
            map.put("leader", obj.getLeader());
            try {
                File catchFile = File.createTempFile(UUID.randomUUID().toString(), ".docx");
                try (
                        InputStream resource = ContractWordServiceldImpl.class.getClassLoader().getResourceAsStream("word/contract.docx");
                        FileOutputStream fileOutputStream = new FileOutputStream(catchFile);
                        FileInputStream fileInputStream = new FileInputStream(catchFile);
                ) {
                    XWPFDocument  word = new MyXWPFDocument(resource);
                    WordExportUtil.exportWord07(word, map);
                    word.write(fileOutputStream);
                    String fileUrl = ossService.uploadOssObject(request.getTenantId(), System.currentTimeMillis() + "/" + fileName, fileInputStream);
                    fileUrls.add(fileUrl);

                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        result.setData(fileUrls);
        result.setCode(200);
        result.setMessage("成功！");
        return result;
    }

}

